<template>
  <div class="range-slider">
    <div ref="track" tabindex="0" class="slider" @mousedown="trackClick" @keydown.left.right="test">
      <div class="color" ref="pathway" :style="widthStyle"></div>
      <div class="bumper"
           :style="leftStyle"
           ref="circle"
           @mousedown.prevent="down"
           @touchstart="down"
      ></div>
    </div>
    <div class="column liner"></div>
    <div class="row range">
      <div class="columns six">
        {{ min }}
      </div>
      <div class="columns six right">
        {{ max }}
      </div>
    </div>
  </div>
</template>

<script>
  const roundPercent = (coeff) => {
    if (coeff >= 0 && coeff <= 1) {
      return Math.round(coeff * 1000) / 10
    } else
    if (coeff > 1) { return 100 }
    return 0
  }

  let canContinue = true

  export default {
    name: 'RangeSlider',
    props: {
      min: {type: Number},
      max: {type: Number},
      value: {},
      step: {type: Number, default: 1}
    },
    data () {
      return {
        // pixels: 0,
        fullOffset: 0,
        percent: (this.value / this.max) * 100,
        percentStep: Number((100 / (this.max / this.step)).toFixed(2)),
        discretedPercent: Math.round(this.percentStep * Math.round(this.percent / this.percentStep))
      }
    },
    methods: {
      getFullOffset (element, sum) {
        if (element.offsetParent) { return this.getFullOffset(element.offsetParent, sum + element.offsetLeft) }
        return sum
      },
      calcFullOffset () {
        this.fullOffset = this.getFullOffset(this.$refs.track, 0)
      },
      meth (e) {
        if (canContinue) {
          // this.pixels = e.clientX - this.fullOffset
          this.discretedPercent = Math.round(this.percentStep * Math.round(this.percent / this.percentStep))
          this.emitInput()
          const clientX = e.clientX || e.touches[0].clientX

          this.percent = roundPercent((clientX - this.fullOffset) / this.$refs.track.offsetWidth)
          canContinue = false
          setTimeout(() => canContinue = true, 25)
        }
      },
      trackClick (e) {
        const clientX = e.clientX || e.touches[0].clientX
        this.percent = roundPercent((clientX - this.fullOffset) / this.$refs.track.offsetWidth)
        // console.log(clientX)
        this.emitInput()
        // this.percent = this.discretedPercent
      },
      mouseUp () {
        this.$emit('mouseup')
        document.removeEventListener('mousemove', this.meth)
        document.removeEventListener('touchmove', this.meth)
        document.removeEventListener('mouseup', this.mouseUp)
        document.removeEventListener('touchend', this.mouseUp)
        this.percent = this.discretedPercent
      },
      down (event) {
        event.stopPropagation()
        this.calcFullOffset()
        this.$refs.track.focus()
        event.preventDefault()
        document.addEventListener('mousemove', this.meth)
        document.addEventListener('touchmove', this.meth)
        document.addEventListener('mouseup', this.mouseUp)
        document.addEventListener('touchend', this.mouseUp)
      },
      test (event) {
        if (event.key === 'ArrowRight') this.percent = roundPercent((Number(this.percent) + Number(this.percentStep)) / 100)
        if (event.key === 'ArrowLeft') this.percent = roundPercent((Number(this.percent) - Number(this.percentStep)) / 100)
        this.emitInput()
      },
      emitInput () {
        this.$emit('input', this.valueToEmit)
      }
    },
    computed: {
      valueToEmit () {
          if(this.percent >= 100) {
              return this.max;
          } else {
              return this.step * Math.round((this.max - this.min) * this.percent / 100 / this.step) + this.min;
          }
      },
      leftStyle () {
        this.percent = Math.min(this.percent, 100);
        return `left: ${this.percent}%;`
        // return `transform: translateX(${this.pixels}px);`
      },
      widthStyle () {
        this.percent = Math.min(this.percent, 100);
        return `width: ${this.percent}%;`
      }
    },
    watch: {
      value: function (newVal) {
      }
    },
    mounted () {
      this.calcFullOffset()
      this.discretedPercent = Math.round(this.percentStep * Math.round(this.percent / this.percentStep))
      window.addEventListener('resize', this.calcFullOffset, true)
    },
    beforeDestroy () {
      window.removeEventListener('resize', this.calcFullOffset, true)
    }
  }
</script>

<style>
</style>
